-- Dialogue choices!
--
-- Requires linedef executor setup for ACS scripts and the like (for now)

freeslot("sfx_dcslct", "sfx_dcopen", "sfx_dccnfm")

local choicesinplay = false
local choices = {} -- Syntax: {[choiceindex] = {linetag, choicename}}
local currentchoice = 1
local choicedelay = 0
local choicetextbest = ""
local choicetextwidth = 0
-- misc constants
local CHOICE_TAG, CHOICE_NAME = 1, 2
local BT_VOTE = (1<<7) -- why is this not exposed
local TRICKTHRESHOLD = 800/2 -- KART_FULLTURN/2

-- taken from LUA_OBSK.lua
local function tableparse(x)
	local y = {}
	local i = 0
	for word in x:gmatch('[^,%s]+') do
		y[i+1] = word 
		i = $+1
	end	
	return y
end

strdraw.register("FANCYMENU", {prefix = "MNUFN", monospace = 8, spacewidth = 4, sepxoffset = -2})

local function initChoices(activator, args, stringargs)
	-- No running on netgames! Strictly singleplayer ONLY. 
	-- Dialogue is singleplayer only anyway...
	if netgame then return end
	
	-- navigate through all of the args 
	-- skip args[0] as that is the name of the lua execute string
	for i = 1, #args-1 do
		if not args[i] then continue end -- not valid
		local str = "Choice "..tostring(i)
		choices[i] = {args[i], str}
		choicetextwidth = max($, strdraw.StringWidth(str, FONT_FANCYMENU))
	end
	
	choicesinplay = true
	currentchoice = 1
	
	S_StartSound(nil, sfx_dcopen)
end

local function choiceNames(activator, args, stringargs)
	-- No running on netgames! Strictly singleplayer ONLY. 
	-- Dialogue is singleplayer only anyway...
	if netgame then return end
	if not choicesinplay then return end
	
	-- stringargs is extremely limited... can only hold 2 strings
	-- first string WILL be taken up as the lua execute name
	-- so instead of doing that, do some mapheaderinfo bullcrap instead
	--
	-- In your mapheader:
	-- Lua.dchoices_choice1 = fuck yeah,no pls
	-- 
	-- In your ACS script:
	-- Lua_Execute("CHOICENAME", 1)

	-- reset the width
	choicetextwidth = 0
	
	local mapchoices = tableparse(mapheaderinfo[gamemap]["dchoices_choice"..tostring(args[1])])
	for i = 1, #mapchoices do
		local str = mapchoices[i]
		-- replace some characters while we're here.
		str = string.gsub(str, "_", " ") -- Replace _ with " "
		str = string.gsub(str, "|", ",") -- Replace | with ","
		choices[i][CHOICE_NAME] = str
		choicetextwidth = max($, strdraw.StringWidth(str, FONT_FANCYMENU))
	end
end

addHook("SpecialExecute", initChoices, "CHOICEINIT")
addHook("SpecialExecute", choiceNames, "CHOICENAME")

local function votePressed()
	return (((server.cmd.buttons & BT_VOTE) == BT_VOTE) and ((server.oldcmd.buttons & BT_VOTE) == 0))
end

local lookingforatag = -1

-- the THINKERRRR
local function choiceThink()
	if netgame then return end
	if not choicesinplay then return end
	if not (server.mo and server.mo.valid) then return end
	
	-- Handle controls
	local cmd, oldcmd = server.cmd, server.oldcmd
	if abs(cmd.throwdir) > TRICKTHRESHOLD and abs(oldcmd.throwdir) <= TRICKTHRESHOLD then
		-- up
		if cmd.throwdir > 0 then currentchoice = $ - 1 end
		-- down
		if cmd.throwdir < 0 then currentchoice = $ + 1 end
		S_StartSound(nil, sfx_dcslct)
		-- wrap around, not clamp
		if currentchoice > #choices then
			currentchoice = 1
		elseif currentchoice < 1 then
			currentchoice = #choices
		end
	end
	if votePressed() then
		local choice = choices[currentchoice]
		-- weirdly enough, ball switches have a defer function that checks if extravalue2 is true...
		-- so, let's abuse that!
		lookingforatag = choice[CHOICE_TAG]
		choicesinplay = false
		S_StartSound(nil, sfx_dccnfm)
	end
end

addHook("MobjThinker", function(mo)
	if netgame then return end
	if lookingforatag == -1 then return end
	-- This works. Apparently.
	if mo.tid == lookingforatag then
		mo.tracer = server.mo
		mo.extravalue2 = 1
		lookingforatag = -1
	end
end, MT_BALLSWITCH_BALL)

addHook("ThinkFrame", choiceThink)

local fuckedfont = false

-- HUD SHIT
local function hudShit(v, p, c)
	if netgame then return end
	
	if not fuckedfont then
		strdraw.forceSentinel(v, FONT_FANCYMENU)
		fuckedfont = true
	end
	
	if not choicesinplay then return end
	
	local x = 10
	local y = 200-64-(#choices*10)
	local flags = V_SNAPTOBOTTOM
	
	v.drawFill(x-5, y-5, choicetextwidth+16+10, (#choices*10)+10, 31|flags|V_TRANSLUCENT)
	local strx = x
	if ((leveltime/5) & 1) then
		strx = $ + 1
	end
	strdraw.draw(v, {
		x = strx, y = (y-1)+((currentchoice-1)*10),
		text = "\x82".."\x1D",
		font = FONT_FANCYMENU,
		sflags = SDF_INTPOS,
		flags = flags
	})
	
	for k, val in ipairs(choices) do
		local text = val[CHOICE_NAME]
		if k == currentchoice then text = "\x82"..text end
		
		strdraw.draw(v, {
			x = x+10, y = y,
			text = text,
			font = FONT_FANCYMENU,
			sflags = SDF_INTPOS,
			flags = flags
		})
		
		y = $ + 10
	end
end

hud.add(hudShit, "game")