-- Blue spheres, for Blue Sphere Land.
freeslot("MT_BSLSPHERE", "S_BSLSPHERE1", "S_BSLSPHERE2")

local FF_FULLBRIGHT = FF_FULLBRIGHT
local FRACUNIT = FRACUNIT

function A_InitBSLSphere(mo)
	-- This will only run once on blue sphere spawn
	-- Take in all possible spawnpoint arguments
	local spawnpoint = mo.spawnpoint
	if not (spawnpoint and spawnpoint.valid) then return end -- NO!
	-- get type
	local motype = spawnpoint.args[0]
	-- Sphere types
	if motype == 1 then -- Red sphere, red color
		mo.color = SKINCOLOR_RED
		-- reduce width
		mo.radius = 12*mapobjectscale
		mo.height = 12*mapobjectscale
	elseif motype == 2 then -- Orange sphere (spring), orange color
		mo.color = SKINCOLOR_ORANGE
	elseif motype == 3 then -- Bumper sphere
		mo.frame = FF_FULLBRIGHT|B
	--elseif motype == 4 then -- TODO: Ourple sphere (teleport), purple color, teleport object
	--	mo.color = SKINCOLOR_LAVENDER
	--elseif motype == 5 then -- TODO: Green sphere, green color, green -> blue -> red
	--	mo.color = SKINCOLOR_GREEN
	else
		mo.color = SKINCOLOR_BLUE
	end
	mo.extravalue1 = motype
	mo.scale = spawnpoint.scale / 2
end

addHook("TouchSpecial", function(sphere, toucher)
	if sphere.extravalue1 == 1 then -- die
		if (toucher.player and toucher.player.valid) then
			-- mmm not exposed so use a funny trick
			toucher.player.tripwireunstuck = 151
		else
			P_KillMobj(toucher, sphere, sphere)
		end
	elseif sphere.extravalue1 == 2 then -- sproing
		if not (toucher.eflags & MFE_SPRUNG) then
			if (toucher.z <= sphere.z + sphere.height/2
				and sphere.z <= toucher.z + toucher.height) then
				K_DoPogoSpring(toucher, 128*mapobjectscale, 1)
			end
		end
	elseif sphere.extravalue1 == 3 then -- bumper
		K_KartBouncing(toucher, sphere)
		if S_IdPlaying(sfx_s3k49) then
			S_StopSoundByID(toucher, sfx_s3k49)
			S_StartSound(toucher, sfx_s1b4)
		end
		-- no momentum
		sphere.momx = 0
		sphere.momy = 0
	else
		S_StartSound(toucher, sfx_s3k65)
		if (toucher.player and toucher.player.valid) then
			toucher.player.ringboost = $ + TICRATE/4
		end
		-- :trollic:
		sphere.color = SKINCOLOR_RED
		sphere.radius = 16*mapobjectscale
		sphere.height = 16*mapobjectscale
		sphere.extravalue1 = 1
		sphere.extravalue2 = TICRATE/3
		sphere.frame = FF_TRANS50|A
		sphere.flags = MF_NOCLIP
	end
	return true
end, MT_BSLSPHERE)

local MF_SPECIAL = MF_SPECIAL
local MF_NOCLIP = MF_NOCLIP
local FF_TRANS30 = FF_TRANS30

-- Prevent players from immediately dying to a blue sphere turning red
addHook("MobjThinker", function(sphere)
	if sphere.extravalue1 == 3 then sphere.frame = FF_FULLBRIGHT|B end
	if sphere.extravalue1 ~= 1 then return end
	if sphere.extravalue2 == 0 then
		sphere.frame = FF_FULLBRIGHT|A
		sphere.flags = MF_SPECIAL
		return
	end
	sphere.frame = FF_FULLBRIGHT|FF_TRANS30|A
	sphere.extravalue2 = $ - 1
	sphere.flags = MF_NOCLIP
end, MT_BSLSPHERE)