-- Deer stuff

freeslot("MT_DEERCUTOUT", "S_DEERCUTOUT1","S_DEERCUTOUT2","S_DEERCUTOUT3", "sfx_hmbebo", "sfx_mnpshk", "sfx_mnpsk1", "sfx_mnpsk2")
sfxinfo[sfx_hmbebo].flags = SF_X4AWAYSOUND
sfxinfo[sfx_mnpshk].flags = SF_X4AWAYSOUND
sfxinfo[sfx_mnpsk1].flags = SF_X4AWAYSOUND
sfxinfo[sfx_mnpsk2].flags = SF_X4AWAYSOUND

addHook("TouchSpecial", function(deer, toucher)
	-- turn into flat cardboard
	if (P_RandomRange(0, 9) == 0) then
		deer.frame = A
		deer.renderflags = RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_SLOPESPLAT|RF_NOSPLATROLLANGLE
		deer.flags = $ & ~MF_SPECIAL
		deer.angle = $ - ANGLE_90
		P_InstaThrust(deer, deer.angle, 32*deer.scale)
		P_SetOrigin(deer, deer.x + deer.momx, deer.y + deer.momy, deer.z)
		deer.momx = 0
		deer.momy = 0
		S_StartSound(deer, sfx_s23b)
		return true
	end
	-- otherwise, explode...
	-- do things before explosion
	
	-- shiiiiiiiiikaaaaaaaa
	local dummy = P_SpawnMobj(deer.x, deer.y, deer.z, MT_THOK)
	dummy.state = S_INVISIBLE
	dummy.fuse = 6*TICRATE
	S_StartSound(dummy, sfx_mnpshk)
	
	-- hitlag as per achii's recommendation
	toucher.hitlag = 1 -- ONLY ONE PLEASE
	local i = 0
	for i = 0,1 do
		local spark = P_SpawnMobj(toucher.x, toucher.y, toucher.z, MT_HITLAG)
		spark.target = toucher
		spark.scale = mapobjectscale*2
		spark.angle = R_PointToAngle2(toucher.x, toucher.y, spark.x, spark.y)
		if (i & 1) then
			spark.angle = $ + ANGLE_90
		end
		spark.hitlag = 3
		spark.color = toucher.color
		spark.colorized = true
	end
	S_StartSound(toucher, sfx_dmgb1)
	
	P_StartQuake(2, 4 * 2 * mapobjectscale, 1536 * mapobjectscale, toucher)
end, MT_DEERCUTOUT)

function A_DeerHop(deer, var1, var2)
	if (((deer.eflags & MFE_VERTICALFLIP) and deer.z + deer.height >= deer.ceilingz)
		or (!(deer.eflags & MFE_VERTICALFLIP) and deer.z <= deer.floorz)) then
		P_SetObjectMomZ(deer, var1*FRACUNIT, false)
		P_InstaThrust(deer, deer.angle - ANGLE_90, FixedMul(var2*FRACUNIT, deer.scale)) -- Launch the hopping action! PHOOM!!
	end
	deer.flags = $ | MF_PUSHABLE
end

addHook("MobjThinker", function(deer)
	if deer.state == S_DEERCUTOUT3 then
		-- explosion sound
		local dummy = P_SpawnMobj(deer.x, deer.y, deer.z, MT_THOK)
		dummy.state = S_INVISIBLE
		dummy.fuse = 3*TICRATE
		S_StartSound(dummy, sfx_hmbebo)
		
		-- random 'shika'
		dummy = P_SpawnMobj(deer.x, deer.y, deer.z, MT_THOK)
		dummy.state = S_INVISIBLE
		dummy.fuse = 2*TICRATE
		S_StartSound(dummy, sfx_mnpsk1 + P_RandomRange(0, 1))
		return
	end
	if deer.state ~= S_DEERCUTOUT2 then return end
	deer.rollangle = $ + ANG20
end, MT_DEERCUTOUT)